diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
index a052ce914..7fe89a8da 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
@@ -3,32 +3,29 @@ package net.minecraft.core.world.generate.chunk.debug;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkDecoratorDebug
-    implements ChunkDecorator
-{
+    implements ChunkDecorator {
     @Override
-    public void decorate(Chunk chunk)
-    {
+    public void decorate(@NotNull Chunk chunk) {
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
         int chunkBlockOffset = chunkX * (Chunk.CHUNK_SIZE_X / 2);
         int chunkMetaOffset = chunkZ * (Chunk.CHUNK_SIZE_Z / 2);
 
-        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++)
-        {
-            for (int z =  0; z < Chunk.CHUNK_SIZE_X; z++)
-            {
+        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
+            for (int z = 0; z < Chunk.CHUNK_SIZE_X; z++) {
                 int blockBlockOffset = x / 2;
                 int blockMetaOffset = z / 2;
 
-                if (x % 2 == 0 && z % 2 == 0)
-                {
+                if (x % 2 == 0 && z % 2 == 0) {
                     int blockId = chunkBlockOffset + blockBlockOffset;
                     int meta = chunkMetaOffset + blockMetaOffset;
 
-                    if (blockId < 0 || blockId >= Blocks.blocksList.length || Blocks.blocksList[blockId] == null) continue;
+                    if (blockId < 0 || blockId >= Blocks.blocksList.length || Blocks.blocksList[blockId] == null)
+                        continue;
 
                     chunk.setBlockIDWithMetadata(x, 0, z, blockId, meta);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkGeneratorDebug.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkGeneratorDebug.java
index 5fc72a338..3c7243f4c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkGeneratorDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkGeneratorDebug.java
@@ -4,18 +4,16 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorDebug
-    extends ChunkGenerator
-{
-    public ChunkGeneratorDebug(World world)
-    {
+    extends ChunkGenerator {
+    public ChunkGeneratorDebug(@NotNull World world) {
         super(world, new ChunkDecoratorDebug());
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk)
-    {
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
         return new ChunkGeneratorResult();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
index 8376e7b5f..6d26e3edc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
@@ -3,15 +3,13 @@ package net.minecraft.core.world.generate.chunk.empty;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkDecoratorEmpty
-    implements ChunkDecorator
-{
+    implements ChunkDecorator {
     @Override
-    public void decorate(Chunk chunk)
-    {
-        if (chunk.pos.x == 0 && chunk.pos.z == 0)
-        {
+    public void decorate(@NotNull Chunk chunk) {
+        if (chunk.pos.x == 0 && chunk.pos.z == 0) {
             chunk.setBlockID(0, 0, 0, Blocks.BEDROCK.id());
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkGeneratorEmpty.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkGeneratorEmpty.java
index 48b21c7b1..0d2bba999 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkGeneratorEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkGeneratorEmpty.java
@@ -4,18 +4,16 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorEmpty
-    extends ChunkGenerator
-{
-    public ChunkGeneratorEmpty(World world)
-    {
+    extends ChunkGenerator {
+    public ChunkGeneratorEmpty(@NotNull World world) {
         super(world, new ChunkDecoratorEmpty());
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk)
-    {
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
         return new ChunkGeneratorResult();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkDecoratorFlat.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkDecoratorFlat.java
index 5527847fa..8968231e1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkDecoratorFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkDecoratorFlat.java
@@ -2,13 +2,12 @@ package net.minecraft.core.world.generate.chunk.flat;
 
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkDecoratorFlat
-    implements ChunkDecorator
-{
+    implements ChunkDecorator {
     @Override
-    public void decorate(Chunk chunk)
-    {
+    public void decorate(@NotNull Chunk chunk) {
         // Do nothing lol
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java
index 50b6e66cc..20b3cd082 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/flat/ChunkGeneratorFlat.java
@@ -5,18 +5,16 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorFlat
-    extends ChunkGenerator
-{
-    public ChunkGeneratorFlat(World world)
-    {
+    extends ChunkGenerator {
+    public ChunkGeneratorFlat(@NotNull World world) {
         super(world, new ChunkDecoratorFlat());
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk)
-    {
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
         for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
index 9073d64aa..c939e2f8b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
@@ -9,32 +9,30 @@ import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.ChunkDecoratorOverworldRetro;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.SurfaceGeneratorOverworldRetro;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorIndev
-    extends ChunkGenerator
-{
-    private final LevelGenerator lg;
-    private final SurfaceGenerator sg;
-    private final CavesLargeFeature cg;
-
-    public ChunkGeneratorIndev(World world, int sizeX, int sizeY, int sizeZ, IndevWorldType worldType, IndevWorldTheme worldTheme)
-    {
+    extends ChunkGenerator {
+    private final @NotNull LevelGenerator lg;
+    private final @NotNull SurfaceGenerator sg;
+    private final @NotNull CavesLargeFeature cg;
+
+    public ChunkGeneratorIndev(@NotNull World world, int sizeX, int sizeY, int sizeZ, @NotNull IndevWorldType worldType, @NotNull IndevWorldTheme worldTheme) {
         super(world, new ChunkDecoratorOverworldRetro(world));
 
-        lg = new LevelGenerator(sizeX, sizeY, sizeZ, worldType, worldTheme);
-        sg = new SurfaceGeneratorOverworldRetro(world);
-        cg = new CavesLargeFeature();
+        this.lg = new LevelGenerator(sizeX, sizeY, sizeZ, worldType, worldTheme);
+        this.sg = new SurfaceGeneratorOverworldRetro(world);
+        this.cg = new CavesLargeFeature();
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk)
-    {
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
-        lg.generate(world, result, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z);
+        this.lg.generate(this.world, result, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z);
 
         // Place bedrock
         for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
@@ -43,8 +41,8 @@ public class ChunkGeneratorIndev
             }
         }
 
-        sg.generateSurface(chunk, result);
-        cg.generate(world, chunkX, chunkZ, result);
+        this.sg.generateSurface(chunk, result);
+        this.cg.generate(this.world, chunkX, chunkZ, result);
 
         return result;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
index 04a27a2b2..a7bd40a6b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
@@ -6,16 +6,17 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.noise.CombinedPerlinNoise;
 import net.minecraft.core.world.noise.RetroPerlinNoise;
+import org.jetbrains.annotations.NotNull;
 
 public final class LevelGenerator {
     private final int sizeX;
     private final int sizeY;
     private final int sizeZ;
 
-    private final IndevWorldType worldType;
-    private final IndevWorldTheme worldTheme;
+    private final @NotNull IndevWorldType worldType;
+    private final @NotNull IndevWorldTheme worldTheme;
 
-    public LevelGenerator(int sizeX, int sizeY, int sizeZ, IndevWorldType worldType, IndevWorldTheme worldTheme) {
+    public LevelGenerator(int sizeX, int sizeY, int sizeZ, @NotNull IndevWorldType worldType, @NotNull IndevWorldTheme worldTheme) {
         this.sizeX = sizeX;
         this.sizeY = sizeY;
         this.sizeZ = sizeZ;
@@ -29,7 +30,7 @@ public final class LevelGenerator {
 
         int layers = 1;
         if (this.worldType == IndevWorldType.FLOATING) {
-            layers = (sizeY - 64) / 48 + 1;
+            layers = (this.sizeY - 64) / 48 + 1;
         }
 
         for (int layer = 0; layer < layers; layer++) {
@@ -49,10 +50,10 @@ public final class LevelGenerator {
                 RetroPerlinNoise edgeNoiseGenerator = new RetroPerlinNoise(seed, 2, 38);
 
                 for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
-                    double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) sizeX - 1.0) - 0.5) * 2.0);
+                    double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) this.sizeX - 1.0) - 0.5) * 2.0);
 
                     for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                        double zDistanceFromCenter = Math.abs(((double) (z + zOffset) / ((double) sizeZ - 1.0) - 0.5) * 2.0);
+                        double zDistanceFromCenter = Math.abs(((double) (z + zOffset) / ((double) this.sizeZ - 1.0) - 0.5) * 2.0);
 
                         // Generate noise to use for height
                         double heightNoiseA = heightNoiseGeneratorA.get((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 6.0 + -4.0;
@@ -118,10 +119,10 @@ public final class LevelGenerator {
             RetroPerlinNoise floatingLayerNoiseGenerator = new RetroPerlinNoise(seed, 8, 80);
 
             for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
-                double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) sizeX - 1.0) - 0.5) * 2.0);
+                double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) this.sizeX - 1.0) - 0.5) * 2.0);
 
                 for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                    double zDistanceFromCenter = Math.abs(((double) (z + zOffset) / ((double) sizeZ - 1.0) - 0.5) * 2.0);
+                    double zDistanceFromCenter = Math.abs(((double) (z + zOffset) / ((double) this.sizeZ - 1.0) - 0.5) * 2.0);
                     double distanceFromCenter = Math.max(xDistanceFromCenter, zDistanceFromCenter);
                     distanceFromCenter = distanceFromCenter * distanceFromCenter * distanceFromCenter;
 
@@ -131,8 +132,8 @@ public final class LevelGenerator {
                     int soilHeight = height + soilNoise;
 
                     heightMap[x + z * Chunk.CHUNK_SIZE_X] = Math.max(height, soilHeight);
-                    if (heightMap[x + z * Chunk.CHUNK_SIZE_X] > sizeY - 2) {
-                        heightMap[x + z * Chunk.CHUNK_SIZE_X] = sizeY - 2;
+                    if (heightMap[x + z * Chunk.CHUNK_SIZE_X] > this.sizeY - 2) {
+                        heightMap[x + z * Chunk.CHUNK_SIZE_X] = this.sizeY - 2;
                     }
 
                     if (heightMap[x + z * Chunk.CHUNK_SIZE_X] <= 0) {
@@ -142,18 +143,18 @@ public final class LevelGenerator {
                     // Determine the minimum height of the layer (only applicable in floating island generation)
                     double floatingLayerNoise = floatingLayerNoiseGenerator.get((double) (x + xOffset) * 2.3, (double) (z + zOffset) * 2.3) / 24.0;
                     int floatingLayerMinY = (int) (Math.sqrt(Math.abs(floatingLayerNoise)) * Math.signum(floatingLayerNoise) * 20.0) + waterLevel;
-                    floatingLayerMinY = (int) ((double) floatingLayerMinY * (1.0 - distanceFromCenter) + distanceFromCenter * (double) sizeY);
+                    floatingLayerMinY = (int) ((double) floatingLayerMinY * (1.0 - distanceFromCenter) + distanceFromCenter * (double) this.sizeY);
                     if (floatingLayerMinY > waterLevel) {
-                        floatingLayerMinY = sizeY;
+                        floatingLayerMinY = this.sizeY;
                     }
 
-                    for (int y = 0; y < sizeY; y++) {
+                    for (int y = 0; y < this.sizeY; y++) {
                         int id = 0;
                         if (y <= height) {
                             id = Blocks.STONE.id();
                         }
 
-                        if (worldType == IndevWorldType.FLOATING && y < floatingLayerMinY) {
+                        if (this.worldType == IndevWorldType.FLOATING && y < floatingLayerMinY) {
                             id = 0;
                         }
 
@@ -169,7 +170,7 @@ public final class LevelGenerator {
             RetroPerlinNoise sandNoiseGenerator = new RetroPerlinNoise(seed, 8, 88);
             RetroPerlinNoise gravelNoiseGenerator = new RetroPerlinNoise(seed, 8, 96);
             int beachHeight = waterLevel - 1;
-            if (worldTheme == IndevWorldTheme.PARADISE) {
+            if (this.worldTheme == IndevWorldTheme.PARADISE) {
                 beachHeight += 2;
             }
 
@@ -178,15 +179,15 @@ public final class LevelGenerator {
                     boolean isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > 8.0;
                     boolean isGravel = gravelNoiseGenerator.get(x + xOffset, z + zOffset) > 12.0;
 
-                    if (worldType == IndevWorldType.ISLAND) {
+                    if (this.worldType == IndevWorldType.ISLAND) {
                         isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > -8.0;
                     }
 
-                    if (worldTheme == IndevWorldTheme.PARADISE) {
+                    if (this.worldTheme == IndevWorldTheme.PARADISE) {
                         isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > -32.0;
                     }
 
-                    if (worldTheme == IndevWorldTheme.HELL || worldTheme == IndevWorldTheme.WOODS) {
+                    if (this.worldTheme == IndevWorldTheme.HELL || this.worldTheme == IndevWorldTheme.WOODS) {
                         isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > -8.0;
                     }
 
@@ -201,7 +202,7 @@ public final class LevelGenerator {
                         int id = -1;
                         if (height <= beachHeight && isSand) {
                             id = Blocks.SAND.id();
-                            if (worldTheme == IndevWorldTheme.HELL) {
+                            if (this.worldTheme == IndevWorldTheme.HELL) {
                                 id = Blocks.GRASS.id();
                             }
                         }
@@ -215,10 +216,10 @@ public final class LevelGenerator {
         }
 
         // Watering phase
-        if (worldType != IndevWorldType.FLOATING) {
+        if (this.worldType != IndevWorldType.FLOATING) {
             for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                 for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                    for (int y = 0; y < sizeY; y++) {
+                    for (int y = 0; y < this.sizeY; y++) {
                         int i = Chunk.makeBlockIndex(x, y, z);
                         int id = result.getBlock(x, y, z);
                         if (id == 0 && y < waterLevel) {
@@ -230,7 +231,7 @@ public final class LevelGenerator {
         }
     }
 
-    public static void generateHouse(World world) {
+    public static void generateHouse(@NotNull World world) {
         int xSpawn = world.getLevelData().getSpawnX();
         int ySpawn = world.getLevelData().getSpawnY();
         int zSpawn = world.getLevelData().getSpawnZ();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
index eccb5ddb1..631bf8df1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
@@ -6,6 +6,7 @@ import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
 import java.util.List;
@@ -14,14 +15,12 @@ import java.util.List;
  * This class provides basic functionality to generate a {@link Chunk chunk} using 3-dimensional Perlin noise.
  */
 public class ChunkGeneratorPerlin
-    extends ChunkGenerator
-{
-    private final TerrainGenerator terrainGenerator;
-    private final SurfaceGenerator surfaceGenerator;
-    private final List<LargeFeature> largeFeatures;
+    extends ChunkGenerator {
+    private final @NotNull TerrainGenerator terrainGenerator;
+    private final @NotNull SurfaceGenerator surfaceGenerator;
+    private final @NotNull List<LargeFeature> largeFeatures;
 
-    protected ChunkGeneratorPerlin(World world, ChunkDecorator decorator, TerrainGenerator terrainGenerator, SurfaceGenerator surfaceGenerator, LargeFeature[] largeFeatures)
-    {
+    protected ChunkGeneratorPerlin(@NotNull World world, @NotNull ChunkDecorator decorator, @NotNull TerrainGenerator terrainGenerator, @NotNull SurfaceGenerator surfaceGenerator, @NotNull LargeFeature @NotNull [] largeFeatures) {
         super(world, decorator);
 
         this.terrainGenerator = terrainGenerator;
@@ -30,13 +29,12 @@ public class ChunkGeneratorPerlin
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk)
-    {
-        double[] densityMap = terrainGenerator.getDensityGenerator().generateDensityMap(chunk);
-        ChunkGeneratorResult result = terrainGenerator.generateTerrain(chunk, densityMap);
-        surfaceGenerator.generateSurface(chunk, result);
-        for (LargeFeature largeFeature : largeFeatures) {
-            largeFeature.generate(world, chunk.pos.x, chunk.pos.z, result);
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
+        double[] densityMap = this.terrainGenerator.getDensityGenerator().generateDensityMap(chunk);
+        ChunkGeneratorResult result = this.terrainGenerator.generateTerrain(chunk, densityMap);
+        this.surfaceGenerator.generateSurface(chunk, result);
+        for (LargeFeature largeFeature : this.largeFeatures) {
+            largeFeature.generate(this.world, chunk.pos.x, chunk.pos.z, result);
         }
 
         return result;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/DensityGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/DensityGenerator.java
index 0a82f783d..f09076970 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/DensityGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/DensityGenerator.java
@@ -2,18 +2,17 @@ package net.minecraft.core.world.generate.chunk.perlin;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
 
 /**
  * This interface provides the ability to generate a 3-dimensional density map, as would be used in a subclass of
  * {@link ChunkGeneratorPerlin} to generate terrain for a {@link Chunk}.
  */
-public interface DensityGenerator
-{
+public interface DensityGenerator {
     /**
      * Reads the density in densities at the given x, y, and z coordinates.
      */
-    static double readDensity(World world, double[] densities, int x, int y, int z)
-    {
+    static double readDensity(@NotNull World world, double @NotNull [] densities, int x, int y, int z) {
         int sizeX = 4 + 1;
         int sizeY = (world.getHeightBlocks() / 8) + 1;
         int sizeZ = 4 + 1;
@@ -23,8 +22,9 @@ public interface DensityGenerator
 
     /**
      * Generates a density map at the given coordinates and of the specified size.
+     *
      * @return A density map with dimensions equal to 5 * 33 * 5, arranged such that a given set of
      * coordinates x, y, z can be accessed by index [(x * 33 * 5) + (z * 33) + y].
      */
-    double[] generateDensityMap(Chunk chunk);
+    double @NotNull [] generateDensityMap(@NotNull Chunk chunk);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/SurfaceGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/SurfaceGenerator.java
index d1e2a2820..33c1e33c2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/SurfaceGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/SurfaceGenerator.java
@@ -2,8 +2,8 @@ package net.minecraft.core.world.generate.chunk.perlin;
 
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
-public interface SurfaceGenerator
-{
-    void generateSurface(Chunk chunk, ChunkGeneratorResult result);
+public interface SurfaceGenerator {
+    void generateSurface(@NotNull Chunk chunk, @NotNull ChunkGeneratorResult result);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGenerator.java
index 920c8a1da..45df4164d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGenerator.java
@@ -2,10 +2,10 @@ package net.minecraft.core.world.generate.chunk.perlin;
 
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
-public interface TerrainGenerator
-{
-    ChunkGeneratorResult generateTerrain(Chunk chunk, double[] densityMap);
+public interface TerrainGenerator {
+    @NotNull ChunkGeneratorResult generateTerrain(@NotNull Chunk chunk, double @NotNull [] densityMap);
 
-    DensityGenerator getDensityGenerator();
+    @NotNull DensityGenerator getDensityGenerator();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
index 227e6d6a0..2452ce03e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
@@ -3,29 +3,27 @@ package net.minecraft.core.world.generate.chunk.perlin;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
 public abstract class TerrainGeneratorLerp
-    implements TerrainGenerator
-{
-    protected final World world;
-    protected final Random rand;
+    implements TerrainGenerator {
+    protected final @NotNull World world;
+    protected final @NotNull Random rand;
 
-    public TerrainGeneratorLerp(World world)
-    {
+    public TerrainGeneratorLerp(@NotNull World world) {
         this.world = world;
         this.rand = new Random();
     }
 
-    protected abstract int getBlockAt(Chunk chunk, int x, int y, int z, double density);
+    protected abstract int getBlockAt(@NotNull Chunk chunk, int x, int y, int z, double density);
 
     @Override
-    public ChunkGeneratorResult generateTerrain(Chunk chunk, double[] densityMap)
-    {
-        int terrainHeight = (world.getWorldType().getMaxY() + 1) - world.getWorldType().getMinY();
+    public @NotNull ChunkGeneratorResult generateTerrain(@NotNull Chunk chunk, double @NotNull [] densityMap) {
+        int terrainHeight = (this.world.getWorldType().getMaxY() + 1) - this.world.getWorldType().getMinY();
 
-        rand.setSeed((long) chunk.pos.x * 0x4F9939F508L + (long) chunk.pos.z * 0x1EF1565BD5L);
+        this.rand.setSeed((long) chunk.pos.x * 0x4F9939F508L + (long) chunk.pos.z * 0x1EF1565BD5L);
 
         // Number of blocks per chunk.
         final int xBlocksPerChunk = Chunk.CHUNK_SIZE_X;
@@ -74,12 +72,9 @@ public abstract class TerrainGeneratorLerp
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
         // Iterate through each blob in the chunk.
-        for (int blobX = 0; blobX < xBlobsPerChunk; blobX++)
-        {
-            for (int blobZ = 0; blobZ < zBlobsPerChunk; blobZ++)
-            {
-                for (int blobY = 0; blobY < yBlobsPerChunk; blobY++)
-                {
+        for (int blobX = 0; blobX < xBlobsPerChunk; blobX++) {
+            for (int blobZ = 0; blobZ < zBlobsPerChunk; blobZ++) {
+                for (int blobY = 0; blobY < yBlobsPerChunk; blobY++) {
                     // Fetches the densities for each corner of the current blob, so we can interpolate between them.
                     final double densityMinXMinYMinZ = densityMap[(((blobX * zDensitiesPerChunk) + blobZ) * yDensitiesPerChunk) + blobY];
                     final double densityMinXMinYMaxZ = densityMap[(((blobX * zDensitiesPerChunk) + (blobZ + 1)) * yDensitiesPerChunk) + blobY];
@@ -102,8 +97,7 @@ public abstract class TerrainGeneratorLerp
                     double yLerpDensityMaxXMinZ = densityMaxXMinYMinZ;
                     double yLerpDensityMaxXMaxZ = densityMaxXMinYMaxZ;
 
-                    for(int yInBlob = 0; yInBlob < yBlocksPerBlob; yInBlob++)
-                    {
+                    for (int yInBlob = 0; yInBlob < yBlocksPerBlob; yInBlob++) {
                         // Determines for each corner on the X axis how much density to add per lerp interval.
                         double xLerpAmountMinZ = (yLerpDensityMaxXMinZ - yLerpDensityMinXMinZ) * xLerpInterval;
                         double xLerpAmountMaxZ = (yLerpDensityMaxXMaxZ - yLerpDensityMinXMaxZ) * xLerpInterval;
@@ -112,19 +106,17 @@ public abstract class TerrainGeneratorLerp
                         double xLerpDensityMinZ = yLerpDensityMinXMinZ;
                         double xLerpDensityMaxZ = yLerpDensityMinXMaxZ;
 
-                        for(int xInBlob = 0; xInBlob < xBlocksPerBlob; xInBlob++)
-                        {
+                        for (int xInBlob = 0; xInBlob < xBlocksPerBlob; xInBlob++) {
                             // Determines for each corner on the Z axis how much density to add per lerp interval.
                             double zLerpAmount = (xLerpDensityMaxZ - xLerpDensityMinZ) * zLerpInterval;
 
                             // Tracks the current interpolated density for the Z coordinate.
                             double zLerpDensity = xLerpDensityMinZ;
 
-                            for(int zInBlob = 0; zInBlob < zBlocksPerBlob; zInBlob++)
-                            {
+                            for (int zInBlob = 0; zInBlob < zBlocksPerBlob; zInBlob++) {
                                 // Determine the coordinates for the block within the blob.
                                 int blockX = xInBlob + blobX * xBlocksPerBlob;
-                                int blockY = yInBlob + blobY * yBlocksPerBlob + world.worldType.getMinY();
+                                int blockY = yInBlob + blobY * yBlocksPerBlob + this.world.worldType.getMinY();
                                 int blockZ = zInBlob + blobZ * zBlocksPerBlob;
 
                                 int id = getBlockAt(chunk, blockX, blockY, blockZ, zLerpDensity);
